package fr.utt.srt.lo02.projet.chatironlagrange.uno;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.Scanner;

import fr.utt.srt.lo02.projet.chatironlagrange.uno.carte.CarteUno;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur.Bot;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur.Joueur;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.Talon;

public class Partie {


	public static boolean sens = true;
	protected static String joueurEnCours;
	public static int nbJoueur = 0;
	public static boolean presenceBOT = false;	
	public static String niveauBOT;

	static JeuDeCarteUno jdc = new JeuDeCarteUno();
	static Pioche pioche = new Pioche();
	public static Talon talon = new Talon();
	
	public static LinkedList<Joueur> Joueurs;
	
	private Scanner menu;
	private static Scanner menu2;
	private Scanner scan;
	private static Scanner tour;
	private static Scanner choix;
	private static Scanner debut;
	
	protected int couleur;
    protected int valeur;
	
	
	public void ajouterJoueur(){
		
		scan = new Scanner(System.in);
		System.out.println("Entrez un nom de joueur : ");
		String joueur = scan.nextLine();
		System.out.println(Joueur.NOM[nbJoueur]+ " : " +joueur+ "\n");
		Joueur J1 = new Joueur(joueur);
		Joueurs.add(J1);
		
	}
	
	public void ajouterBot(){
		
		String bot = "BOT";
		System.out.println(Joueur.NOM[nbJoueur]+ " : " + bot+ "\n");
		Joueur J2 = new Joueur(bot);
		Joueurs.add(J2);
		presenceBOT = true;
	}
	
	
	public static void choisirDifficulteBot(){
		
		boolean partieEnCours = false;
		/*
		 * Methode qui permet de choisir la difficult du bot
		 */

		System.out.println("\nChoississez la difficult des BOTs \n");
		
		while(partieEnCours==false){
		
		System.out.println("Choix 1 : Facile/Easy");
		System.out.println("Choix 2 : Moyen/Medium");
		System.out.println("Choix 3 : Difficile/Hard");
		
		menu2 = new Scanner(System.in);
		String choix = menu2.nextLine();
		
		switch(choix){
		
		case "1":
			/*
			 * Le bot cre sera de niveau facile 
			 * utiliser JouerFacile(); 
			 */
			niveauBOT = "facile";
			partieEnCours=true;
			break;
			
		case "2":
			/*
			 * Le bot cre sera de niveau moyen
			 * utiliser JouerMoyen();
			 */
			
			niveauBOT = "moyen";
			partieEnCours=true;
			break;
			
		case "3":
			/*
			 * Le bot cre sera de niveau difficile
			 * utiliser JouerDifficile();
			 */
			
			niveauBOT = "difficile";
			partieEnCours=true;
			break;
			
		default:
			/*
			 * affiche une erreur si le nombre entr n'est pas correcte
			 */
			System.out.println("Error ! Vous n'avez pas entr un bon choix \n");
			
			break;
	
		}
		
		
		}
		
	}
		
	
	

	public void commencerJeu() {
		
		Partie.Joueurs = new LinkedList<Joueur>();
		boolean leave = false;
	
		System.out.println("Commencer une nouvelle partie \n");
		
		while (leave == false) {
			
			System.out.println("Choix 1 : Ajouter Joueur");
			System.out.println("Choix 2 : Ajouter BOT");
			System.out.println("Choix 3 : Commencer partie");
			System.out.println("Votre choix : ");

			menu = new Scanner(System.in);
			String choix = menu.nextLine();

			switch (choix) {

			case "1":
				
				if(nbJoueur<10){
					
				ajouterJoueur();
				nbJoueur++;
				}
				
				else
				System.out.println("Il faut au maxi 10 joueurs");
				
				break;

			case "2":
				/*
				 * Mthode qui permet d'ajouter un bot
				 * 
				 */
				
				if(nbJoueur<10){
					
				
				ajouterBot();
				
				nbJoueur++;
				
				
				
				}
				
				else
					System.out.println("Il faut au maxi 10 joueurs");
				
				break;

			case "3":

				/*
				 * Mthode qu'on avait dans la class Test.
				 * Dans la class test, il ne reste plus que la mthode pour cre un nouvelle partie, qui appellera la 
				 * methode commencerPartie();
				 */
				
				if(nbJoueur<2){
					System.out.println("il faut au minimum 2 joueurs");
				}
				
				else{
				System.out.println("il y a "+nbJoueur+" joueurs dans la partie");
				System.out.println("La partie commence, on peut distribuer les cartes \n");
				Partie.commencerPartie();
				leave=true;
				}
				
				break;
				
			default:
				/*
				 * Si l'on ne rentre pas un chiffre parmis ceux que l'on
				 * demande. Nanmoins, si l'on rentre une lettre, ou un symbole,
				 * a gnre une erreur, donc faudra trouver le moyen de bloqu
				 * ca, ou d'y mettre une exception
				 */
				System.out.println("Vous n'avez pas entr un nombre correct ! ");
				
				break;
			}
		}
	}
	
	private static void commencerPartie() {
		
		int i =  0;
		if(presenceBOT == true){
			choisirDifficulteBot();
		}
		
		//System.out.println(jdc.getCarte());
		
		jdc.melangerCarte();
		
		Distribuer();
		
		
		talon.afficherCartePremiereTalon(Pioche.tirerCarte());
		
		if(talon.getValeur()==10){
			i++;
			Tour(i);
		}
		else if(talon.getValeur()==11){
			determinerSens(); 
			Tour(nbJoueur-1);
		}
		else if(talon.getValeur()==12){
			
			for(int k=0;k<2;k++){
			Joueurs.get(i).prendreCarte(Pioche.tirerCarte());
			}
			
			i++;
			Tour(i);
		}
		else if(talon.getValeur()==13){
			
			System.out.println(Joueurs.get(i).getNom()+ " doit choisir une couleur \n");
			
			if(Joueurs.get(i).getNom()!="BOT"){
				
				
				System.out.println("Choix 1: Jaune");
				System.out.println("Choix 2: Bleu");
				System.out.println("Choix 3: Rouge");
				System.out.println("Choix 4: Vert");
				

				debut = new Scanner(System.in);
				int choixcouleur = debut.nextInt();
				
				switch(choixcouleur){
				
				case 1 :
					
					talon.setCouleur(0);
					System.out.println("Couleur demande : Jaune" );

					break;
				
				case 2 :
					talon.setCouleur(1);
					System.out.println("Couleur demande : Bleu");

					break;
					
				case 3 :
					talon.setCouleur(2);
					System.out.println("Couleur demande : Rouge");

					break;
					
				case 4 :
					talon.setCouleur(3);
					System.out.println("Couleur demande : Vert");

					break;

				}
			
				}
				else{
								
					int num = (int)(Math.random() * 4);
					talon.setCouleur(num);
					System.out.println("Couleur demande : " +talon.getCouleur());
					
					
					
				}
			
			Tour(i);
			
		}
		else if(talon.getValeur()==14){
			System.out.println("On tire une autre carte car Plus4 tire");
			talon.afficherCartePremiereTalon(Pioche.tirerCarte());
			Tour(i);
		}
		else{		
		Tour(i);
		}
				

}
		
		
	public static void Tour(int i){
		
		//nbCarteValide(i);
	
		/*
		 * Affiche les caractristiquent de la carte Talon
		 */
		// TestTalon();
		afficherJoueurEnCours(i);
				
		if(verificationMainJoueur()==false ){
		
		//while(verificationMainJoueur()==false){
		
			if(nbCarteValide(i)==true){
			
				if(Joueurs.get(i).getNom() != "BOT"){
					
					tour = new Scanner(System.in);
					System.out.println("Quelle carte jouer ?");
					int carteAPoser = tour.nextInt();
			
					/*
					 * Cration d'une carte qui s'appel carteTest, et qui prend les caractristiques de la carte que l'on souhaite jouer.
					 * Celle-ci servira donc pour valider le coup
					 */
					
					CarteUno carteTest = new CarteUno(Joueurs.get(i).main.get(carteAPoser).getValeur(), Joueurs.get(i).main.get(carteAPoser).getCouleur(), 0);
			
					if(Joueurs.get(i).main.get(carteAPoser).getValeur()==11 && carteTest.CoupValide(carteTest, talon) == true ){
						
						determinerSens();
						talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser));	
						Joueurs.get(i).JouerCarte(carteAPoser);
						System.out.println("Le sens de la partie change \n");
				
						if(i==0 && nbJoueur==2){
							i=0;
							//afficherJoueurEnCours(i);
							Tour(i);
						}
						else if(i==1 && nbJoueur==2){
							i=1;
							//afficherJoueurEnCours(i);
							Tour(i);
						}
				
					}
			
					else if(Joueurs.get(i).main.get(carteAPoser).getEffet()==2 && carteTest.CoupValide(carteTest, talon) == true ){		//si la carte est noire et donc soit plus4 ou joker, on ne vrifie pas, on pose, c'est tout car ces cartes peut aller sur n'importe quelle couleur et mm valeur
	
						//System.out.println("Carte talon : " +talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser)));		//on ractualise la talon  l'affichage pour le prochain joueur
						piocher(i,2);
						talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser));	
						Joueurs.get(i).JouerCarte(carteAPoser);
		
						System.out.println("Le joueurs suivant a piocher 2 cartes et passe son tour \n");
						
						if(sens==true){
							
							if(i==nbJoueur-2 && nbJoueur>2){
								i=0;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
							else if(i!=nbJoueur-1 && nbJoueur>2){
								i=i+2;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
							else if(i!=nbJoueur-1 && nbJoueur==2){
								i=0;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
							else if(i==nbJoueur-1 && nbJoueur>2){
								i=1;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
							else{
								i=1;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
						}
						else if(sens==false){

							if(i>=2 && nbJoueur>2){
								i=i-2;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
							else if(i==1){
								i=nbJoueur-1;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
							else if(i==0 ){
								i=nbJoueur-2;
								//afficherJoueurEnCours(i);
								Tour(i);
							}

						}
					}
					
						else if(Joueurs.get(i).main.get(carteAPoser).getValeur()==14){		//si la carte est noire et donc soit plus4 ou joker, on ne vrifie pas, on pose, c'est tout car ces cartes peut aller sur n'importe quelle couleur et mm valeur
				
							//System.out.println("Carte talon : " +talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser)));		//on ractualise la talon  l'affichage pour le prochain joueur
				
							ChangementCouleur(carteAPoser, i);
							talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser));	
							Joueurs.get(i).JouerCarte(carteAPoser);
							piocher(i,4);
				
							System.out.println("Le joueurs suivant a piocher 4 cartes et passe son tour \n");
							
							if(sens==true){
								
								if(i==nbJoueur-2 && nbJoueur>2){
									i=0;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
								else if(i!=nbJoueur-1 && nbJoueur>2){
									i=i+2;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
								else if(i!=nbJoueur-1 && nbJoueur==2){
									i=0;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
								else if(i==nbJoueur-1 && nbJoueur>2){
									i=1;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
								else{
									i=1;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
							}
							else if(sens==false){

								if(i>=2 && nbJoueur>2){
									i=i-2;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
								else if(i==1){
									i=nbJoueur-1;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
								else if(i==0 ){
									i=nbJoueur-2;
									//afficherJoueurEnCours(i);
									Tour(i);
								}

							}
				
							// System.out.println("CA MARCHE !!!!!!!!!!!!!!!!! Carte spciale !! COUP VALIDE");
				
						}
					
							else if(Joueurs.get(i).main.get(carteAPoser).getValeur()==13){		//si la carte est noire et donc soit plus4 ou joker, on ne vrifie pas, on pose, c'est tout car ces cartes peut aller sur n'importe quelle couleur et mm valeur
				
								//System.out.println("Carte talon : " +talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser)));		//on ractualise la talon  l'affichage pour le prochain joueur
				
								ChangementCouleur(carteAPoser, i);
								talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser));	
								Joueurs.get(i).JouerCarte(carteAPoser);
							}
								
								else if(Joueurs.get(i).main.get(carteAPoser).getValeur()==10 && carteTest.CoupValide(carteTest, talon) == true ){	//Carte passer tour	
					
									//System.out.println("Carte talon : " +talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser)));		//on ractualise la talon  l'affichage pour le prochain joueur
				
									talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser));		//on ractualise la talon  l'affichage pour le prochain joueur
					
									Joueurs.get(i).JouerCarte(carteAPoser);
					
									System.out.println("Le joueur suivant ne peut pas jouer \n");
					
									if(sens==true){
						
										if(i==nbJoueur-2 && nbJoueur>2){
											i=0;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
										else if(i!=nbJoueur-1 && nbJoueur>2){
											i=i+2;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
										else if(i!=nbJoueur-1 && nbJoueur==2){
											i=0;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
										else if(i==nbJoueur-1 && nbJoueur>2){
											i=1;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
										else{
											i=1;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
									}
									else if(sens==false){
				
										if(i>=2 && nbJoueur>2){
											i=i-2;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
										else if(i==1){
											i=nbJoueur-1;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
										else if(i==0 ){
											i=nbJoueur-2;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
			
									}	
						
								}
								else if(carteTest.CoupValide(carteTest, talon) == true){
				
									//TestCarteAPoser(carteAPoser, i);
					
									talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser));		//on ractualise la talon  l'affichage pour le prochain joueur
				
									Joueurs.get(i).JouerCarte(carteAPoser);
		
									//System.out.println("CA MARCHE !!!!!!!!!!!!!!!!! COUP VALIDE");
					
									}	
									else{
										System.out.println("coup non valide");
										//afficherJoueurEnCours(i);
										Tour(i);
									}
			
				}
				else{
					if(niveauBOT=="facile"){
						Bot.JouerFacile(i);
					}
					else if(niveauBOT == "moyen"){
						Bot.JouerMoyen(i);
					}
					else{
						Bot.JouerDifficile(i);
					}
				}
			}
			
		if(sens==true){
			if(i!=nbJoueur-1){
				i++;
				//afficherJoueurEnCours(i);
				Tour(i);
			}
			else{
				i=0;
				//afficherJoueurEnCours(i);
				Tour(i);
			}
		}
		else if(sens==false){
			if(i!=0){
				i--;
				//afficherJoueurEnCours(i);
				Tour(i);
			}
			else if(i==0 && nbJoueur>2){
				i=nbJoueur-1;
				//afficherJoueurEnCours(i);
				Tour(i);
			}
			else if(i==0 && nbJoueur==2){
				i=nbJoueur-1;
				//afficherJoueurEnCours(i);
				Tour(i);
			}
		}
		
		}
	
		
	}
	
	public static void Score(int k){
		int score = 0;
		int scoretot = 0;
		
			for(int i=0; i<nbJoueur; i++){
				for(int t=0; t<Joueurs.get(i).main.size();t++){
					// Carte Chiffre
					if(Joueurs.get(i).main.get(t).getEffet()==1){
						score+=Joueurs.get(i).main.get(t).getValeur();
						// Carte +2	
					}
					if(Joueurs.get(i).main.get(t).getEffet()==2){
						score+=20;
						// Carte Inversion	
					}
					if(Joueurs.get(i).main.get(t).getEffet()==11){
						score+=20;
						// Carte passer Tour	
					}
					if(Joueurs.get(i).main.get(t).getEffet()==10){
						score+=20;
						// Carte Joker	
					}
					if(Joueurs.get(i).main.get(t).getValeur()==13){
						score+=50;
						// Carte +4	
					}
					if(Joueurs.get(i).main.get(t).getValeur()==14){
						score+=50;
					}
				}
				Joueurs.get(i).setScore(score);
				//System.out.println("La main sc de "+Joueurs.get(i).getNom()+" est de "+score+" points");
				//System.out.println("La main de "+Joueurs.get(i).getNom()+" est de "+Joueurs.get(i).getScore()+" points");
			}
			
			for(int i=0; i<nbJoueur; i++){
			scoretot+=Joueurs.get(i).getScore();
			}
			System.out.println("Le score de "+Joueurs.get(k).getNom()+" est de "+scoretot+" points");
			
	}
		
		
	@SuppressWarnings("static-access")
	public static void ChangementCouleur(int carteAPoser, int i) {
		
		if(Joueurs.get(i).getNom()!="BOT"){
			
		
		System.out.println("Choix 1: Jaune");
		System.out.println("Choix 2: Bleu");
		System.out.println("Choix 3: Rouge");
		System.out.println("Choix 4: Vert");
		

		choix = new Scanner(System.in);
		int choix1 = choix.nextInt();
		
		switch(choix1){
		
		case 1 :
			
			Joueurs.get(i).main.get(carteAPoser).setCouleur(0);
			System.out.println("***** Couleur demande : " +Joueurs.get(i).main.get(carteAPoser).COULEURS[Joueurs.get(i).main.get(carteAPoser).getCouleur()]);

			break;
		
		case 2 :
			Joueurs.get(i).main.get(carteAPoser).setCouleur(1);
			System.out.println("***** Couleur demande : " +Joueurs.get(i).main.get(carteAPoser).COULEURS[Joueurs.get(i).main.get(carteAPoser).getCouleur()]);

			break;
			
		case 3 :
			Joueurs.get(i).main.get(carteAPoser).setCouleur(2);
			System.out.println("***** Couleur demande : " +Joueurs.get(i).main.get(carteAPoser).COULEURS[Joueurs.get(i).main.get(carteAPoser).getCouleur()]);

			break;
			
		case 4 :
			Joueurs.get(i).main.get(carteAPoser).setCouleur(3);
			System.out.println("***** Couleur demande : " +Joueurs.get(i).main.get(carteAPoser).COULEURS[Joueurs.get(i).main.get(carteAPoser).getCouleur()]);

			break;

		}
	
		}
		else{
						
			int num = (int)(Math.random() * 4);
			Joueurs.get(i).main.get(carteAPoser).setCouleur(num);
			System.out.println("***** Couleur demande : " +Joueurs.get(i).main.get(carteAPoser).COULEURS[Joueurs.get(i).main.get(carteAPoser).getCouleur()]);
			
			
			
		}
			
		
	}
	
	public static void regenererPioche(){				//on regenere une pioche si plus de cartes dans la pioche mais seulement si il y a plus de 2 cartes dans le talon sinon on ne peut regnerer la pioche
		if(Talon.Carte.size()>=2){
		for(int i=0;i<Talon.Carte.size()-2;i++){ 			//Carte.size()-1 correspond a la derniere carte de talon (getLast()) donc on s'arrete  l'avant dernier, donc -2
			System.out.println("Pioche regnre");
			jdc.JDC.add(Talon.Carte.remove(i));
			//System.out.println(jdc);
			Pioche.Melanger();
			//Pioche.getCarte();
		}
		}
	}
	

	public static boolean piocher(int i, int n){
		
		if(sens==true){
		for(int k =0; k<n;k++){
			if(i!=nbJoueur-1){
				if(Pioche.pioche.JDC.size()==0){
					regenererPioche();
				}
				Joueurs.get(i+1).prendreCarte(Pioche.tirerCarte());
			}
			else{
				if(Pioche.pioche.JDC.size()==0){
					regenererPioche();
				}
				Joueurs.getFirst().prendreCarte(Pioche.tirerCarte());
			}
			
		}
		}
		else if(sens==false){
			for(int k =0; k<n;k++){
				if(i!=0){
					if(Pioche.pioche.JDC.size()==0){
						regenererPioche();
					}
					Joueurs.get(i-1).prendreCarte(Pioche.tirerCarte());
				}
				else{
					if(Pioche.pioche.JDC.size()==0){
						regenererPioche();
					}
					Joueurs.getLast().prendreCarte(Pioche.tirerCarte());
				}
			}
		}
		return false;
	
	}	
		

	private static void afficherJoueurEnCours(int i) {
		System.out.println("Talon :  " +talon.afficherCarte()+"\n");
		System.out.println(Joueurs.get(i).getNom()+ " doit jouer \n");
		//if(Joueurs.get(i).getNom()!="BOT"){
		System.out.println("Main de " +Joueurs.get(i).getNom()+ " :  " );
		System.out.println(Joueurs.get(i));
		//}
	}
	

	public static void determinerSens() {
		
		if(sens==false){
			sens=true;
		}else if(sens==true){
			sens=false;
		}
	}
	
	public static void Distribuer() {
		
		int i;	
		
		Iterator<Joueur> it = Joueurs.iterator();
				
		while(it.hasNext()){
					
		Joueur J = (Joueur) it.next();
					
			for(i=0;i<7;i++){
						
			J.prendreCarte(jdc.tirerCarte());
					
			}
		}						
	}
	
		
	public void  carteTest(int valeur, int couleur, int i, int carteAPoser){
		this.valeur=Joueurs.get(i).main.get(carteAPoser).getValeur();
		this.couleur=Joueurs.get(i).main.get(carteAPoser).getCouleur();
}
	
	
	public static void TestCarteAPoser(int carteAPoser, int i){
		System.out.println("TestCarteAPoser: ");
		System.out.println("valeur carte jouer: "+Joueurs.get(i).main.get(carteAPoser).getValeur());
		System.out.println("couleur carte jouer: "+Joueurs.get(i).main.get(carteAPoser).getCouleur());
}
	
	public static boolean verificationMainJoueur(){
		
		for(int i=0;i<nbJoueur-1;i++){
			if(Joueurs.get(i).main.size()==0){
				System.out.println("******* Le gagnant est : " +Joueurs.get(i).getNom()+" *******");
				Score(i);
				return true;
			}
		}
		return false;
		
	}
	
	
	public static boolean nbCarteValide(int i){
		int nombreCarteValide=0;
		
		for(int o=0; o<Joueurs.get(i).main.size(); o++){
			
			CarteUno u = new CarteUno(Joueurs.get(i).main.get(o).getValeur(), Joueurs.get(i).main.get(o).getCouleur(), 0);

			if(u.CoupValide(u, talon)==true){
				nombreCarteValide++;
				
			}else if(Joueurs.get(i).main.get(o).getValeur()== 13){
				Joueurs.get(i).main.get(0);
				nombreCarteValide++;
			}
			else if(Joueurs.get(i).main.get(o).getValeur()==14){
				Joueurs.get(i).main.get(0);
				nombreCarteValide++;
			}
//			else if(Joueurs.get(i).main.get(o).getEffet()== 1){
//				Joueurs.get(i).main.get(0);
//				nombreCarteValide++;
//			}
			
		}
		
		if(nombreCarteValide==0){
			
			System.out.println("Vous avez "+nombreCarteValide+" carte pouvant tre jou");
			if(Pioche.pioche.JDC.size()==0){
				regenererPioche();
			}
			
			Joueurs.get(i).prendreCarte(Pioche.tirerCarte());
			
			if(Joueurs.get(i).main.getLast().CoupValide(Joueurs.get(i).main.getLast(), talon)==true){
				System.out.println("\n ************ Bonne Pioche ************ \n A vous de jouer la carte n"+(Joueurs.get(i).main.size()-1)+"\n");
				Tour(i);
			}
			else if(Joueurs.get(i).main.getLast().getValeur()==talon.getValeur() || Joueurs.get(i).main.getLast().getCouleur()==talon.getCouleur()){
				System.out.println("\n ************ Bonne Pioche ************ \n A vous de jouer la carte n"+(Joueurs.get(i).main.size()-1)+"\n");
//				talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(Joueurs.get(i).main.size()-1));
//				Joueurs.get(i).JouerCarte(Joueurs.get(i).main.size()-1);
				Tour(i);
			}
			else if(Joueurs.get(i).main.getLast().getValeur()==13 || Joueurs.get(i).main.getLast().getValeur()==14){
				System.out.println("\n ************ Bonne Pioche ************ \n A vous de jouer la carte n"+(Joueurs.get(i).main.size()-1)+"\n");
				//ChangementCouleur(Joueurs.get(i).main.size()-1,i);
				Tour(i);
			}
			
			
			return false;
			
		}else if(nombreCarteValide!=0){
			System.out.println("Vous avez "+nombreCarteValide+" cartes pouvant tre jous");
			return true;
		}
		
		return false;
		
	}

	
	public static void TestTalon(){
		System.out.println("TestTalon:");
		talon.getTalon();
	}		
}



