package fr.utt.srt.lo02.projet.chatironlagrange.uno.carte;

import fr.utt.srt.lo02.projet.chatironlagrange.uno.Talon;

public class CarteUno {

	public final static int Zero = 0;
	public final static int Un = 1;
	public final static int Deux = 2;
	public final static int Trois = 3;
	public final static int Quatre = 4;
	public final static int Cinq = 5;
	public final static int Six = 6;
	public final static int Sept = 7;
	public final static int Huit = 8;
	public final static int Neuf = 9;
	
	public final static int PasserTour = 10;
	public final static int Inversion = 11;
	public final static int Plus2 = 12;
	
	public final static int Joker = 13;
	public final static int Plus4 = 14;
	
	public final static int Jaune = 0;
	public final static int Bleu = 1;
	public final static int Rouge = 2;
	public final static int Vert = 3;
	public final static int Noir = 4;
	
	public final static String[] COULEURS = {"Jaune", "Bleu", "Rouge", "Vert","Noir"};
    public final static String[] VALEURS = {"Zero", "Un", "Deux", "Trois", "Quatre", "Cinq", "Six", "Sept", "Huit", "Neuf", "PasserTour", "Inversion", "Plus2", "Joker", "Plus4"};

    protected int couleur;
    protected int valeur;
    protected int effet;
    
    public CarteUno (int valeur, int couleur, int p) {
    	this.setCouleur(couleur);
    	this.setValeur(valeur);
    	this.effet=p;
        }
    
   

    public int getCouleur() {
		return couleur;
	}
    
    public int getEffet(){
    	return effet;
    }
    

    public void setCouleur(int couleur) {
	
		    this.couleur = couleur;
		
	}
        
	public int getValeur() {
		return valeur;
	}

	public void setValeur(int valeur) {
		
		    this.valeur = valeur;
			
	}

    public String toString() {
    	if (valeur >= CarteUno.Zero && valeur <= CarteUno.Plus2) {
		    return 	CarteUno.VALEURS[this.valeur] + CarteUno.COULEURS[this.couleur];
		    }		
    	else {
    		return 	CarteUno.VALEURS[this.valeur];
    	}
    }
/*
	public boolean CoupValide(CarteUno carte, Talon talon){
		System.out.println("mauvaise mthode");
		return true;
		
	}*/



    public boolean CoupValide(CarteUno carteTest, Talon talon){
		if(carteTest.getCouleur()==talon.getCouleur()){
			System.out.println("ok carte uno couleur");
			return true;
		}else if(carteTest.getValeur()==talon.getValeur()){
			System.out.println("ok carte uno valeur");
			return true;
		}else{
			return false;
		}	
	}

}


	


